/* $Id: io-FreeBSD.c,v 1.1 2001/03/19 13:47:12 tcg Exp $ */

/* FreeBSD Compatibility.. */

#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <net/if.h>
#include <net/if_var.h>
#include <kvm.h>
#include <fcntl.h>

#include "trafdisp.h"

char *interface;

static struct nlist nl[] = 
  {
#define N_IFNET 0
    { "_ifnet" },
    { "" },
  };

static kvm_t *kvmd;
char *nlistf = NULL, *memf = NULL;

int kread( u_long addr, char *buf, int size )
{
  if( kvmd == 0 )
      return 1;
  if( !buf )
    return 0;
  if( kvm_read( kvmd, addr, buf, size ) != size )
      return 1;
  return 0;
}

int intpr( struct io_stat *io )
{
  struct ifnet ifnet;
  u_long ifaddraddr;
  char name[IFNAME_MAX], tname[16];
  struct ifnethead ifhead;
  u_long ifnetaddr;
  ifnetaddr = nl[N_IFNET].n_value;
  if( ifnetaddr == 0 )
    {
      return 1;
    }
  if( kread( ifnetaddr, (char *) &ifhead, sizeof( ifhead ) ) )
    {
      return 1;
    }
  ifnetaddr = (u_long) ifhead.tqh_first;
  if( kread( ifnetaddr, (char *) &ifnet, sizeof( ifnet ) ) )
    {
      return 1;
    }
  ifaddraddr = 0;
  while( ifnetaddr || ifaddraddr )
    {
      if( ifaddraddr == 0 )
	{
	  if( kread( ifnetaddr, (char *)&ifnet, sizeof( ifnet ) ) )
	    return 1;
	  if( kread( (u_long) ifnet.if_name, tname, 16 ) )
	    return 1;
	  snprintf( name, IFNAME_MAX, "%s%d", tname, ifnet.if_unit );
	  ifnetaddr = (u_long) ifnet.if_list.tqe_next;
	  if( interface != 0 )
	    if( strcmp( name, interface ) == 0 )
	      break;
	    else 
	      continue;
	  else
	    break;
	}
    }
  strncpy( io->ifname, name, IFNAME_MAX );
  io->ibytes = ifnet.if_ibytes;
  io->obytes = ifnet.if_obytes;
  return 0;
}

int init_kvm( )
{
  char buf[512];
  if( ( kvmd = kvm_openfiles( nlistf, memf, NULL, O_RDONLY, buf ) ) == NULL )
    {
      fprintf( stderr, "Unable to init kvm: %s\n", buf );
      return 1;
    }
  if( kvm_nlist( kvmd, nl ) < 0 || nl[0].n_type == 0 )
    {
      fprintf( stderr, "kvm: no namelist\n" );
      return 1;
    }
  return 0;
}
