/* $Id: io-Linux.c,v 1.2 2001/03/23 14:58:23 tcg Exp $ */

/* Linux Compatibility.. */
/* Note: This file also contains compantibily functions that doesn`t exist on linux, such as daemon() */


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <unistd.h>
#include <fcntl.h>

#include "trafdisp.h"

#define PROCFILE "/proc/net/dev"

char *interface;
FILE *proc_fd;

void strip_spaces( char **in );

/* This can _surely_ be optimized, but I wanted to have a Linux port asap. */
/* Assumes that PROC_FILE format is:
 * <2 useless lines>
 * interface: ibytes field field field field field field field obytes more-fields\n
 */
int intpr( struct io_stat *io )
{
  char buf[ BUFSIZ ], *pbuf, *tmpbuf, *tok;
  int wordloc;

  pbuf = buf;
  memset( buf, 0, BUFSIZ );
  /* skip the first two lines, we dont need them */
  fgets( buf, BUFSIZ, proc_fd );
  fgets( buf, BUFSIZ, proc_fd );
  if( interface )
    {
      while( fgets( buf, BUFSIZ, proc_fd ) )
	{
	  buf[strlen(buf)-1] = 0;
	  strip_spaces( &pbuf );
	  tmpbuf = pbuf + 1; /* skip the leading space */
	  if( !strncmp( tmpbuf, interface, strlen( interface ) ) )
	    {
       	      break;
	    }
	} 
    } else {
      fgets( buf, BUFSIZ, proc_fd );
      buf[strlen(buf)-1] = 0;
      strip_spaces( &pbuf );
      tmpbuf = pbuf + 1;
    }
  pbuf = strchr( tmpbuf, ':' )+1;
  tmpbuf = pbuf;
  wordloc = 0;
  while( tmpbuf )
    {
      tok = strsep( &tmpbuf, " " );
      if( !*tok )
	continue;
      wordloc++;
      if( wordloc == 1 ) /* incoming bytes/sec */
	{
	  io->ibytes = atol( tok );
	  continue;
	}
      if( wordloc == 9 ) /* outgoing bytes/sec */
	{
	  io->obytes = atol( tok );
	  break;
	}
    }
  /* /proc sucks... */
  fclose( proc_fd );
  return init_kvm( );
}

int init_kvm( )
{
  proc_fd = fopen( PROCFILE, "r" );
  if( !proc_fd )
    {
      fprintf( stderr, "Unable to open %s for reading.\n", PROCFILE );
      return 1;
    }
  return 0;
}

void strip_spaces( char **in )
{  
  char *str;
  int strip, gotspace;
	
  str = *in;
  strip = 1;
  gotspace = 0;
  while( *str ) {
    switch( *str ) {
    case '"':
      if( *(str-1) != '\\' )
	strip = ! strip;
      str++;
      break;
    case ' ':
    case '\t':
      if( strip ) {
	if( gotspace ) {
	  strcpy( str, str+1 );
	} else {
	  gotspace = 1;
	  str++;
	} 
      } else {
	str++;
      }
      break;
    default:
      gotspace = 0;
      str++;
    }
  }
}

int daemon( int nochdir, int noclose )
{
  int fd;
  switch( fork() )
    {
    case -1:
      return -1;
    case 0:
      break;
    default:
      exit( 0 );
    }
  if( setsid() == -1 )
    return -1;

  if( !nochdir )
    chdir( "/" );

  if( !noclose && (fd = open( "/dev/null", O_RDWR, 0 ) ) != -1 )
    {
      dup2( fd, STDIN_FILENO );
      dup2( fd, STDOUT_FILENO );
      dup2( fd, STDERR_FILENO );
      if( fd > 2 )
	close( fd );
    }
  return 0;
}
