/* $Id: io-NetBSD.c,v 1.2 2001/03/29 08:17:20 tcg Exp $ */

/* NetBSD Compatibility.. */

#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <net/if.h>
#include <kvm.h>
#include <fcntl.h>

#include "trafdisp.h"

char *interface;

struct nlist nl[] = {
#define	N_MBSTAT	0
	{ "_mbstat" },
#define	N_IPSTAT	1
	{ "_ipstat" },
#define	N_TCBTABLE	2
	{ "_tcbtable" },
#define	N_TCPSTAT	3
	{ "_tcpstat" },
#define	N_UDBTABLE	4
	{ "_udbtable" },
#define	N_UDPSTAT	5
	{ "_udpstat" },
#define	N_IFNET		6
	{ "_ifnet" },
#define	N_IMP		7
	{ "_imp_softc" },
#define	N_ICMPSTAT	8
	{ "_icmpstat" },
#define	N_RTSTAT	9
	{ "_rtstat" },
#define	N_UNIXSW	10
	{ "_unixsw" },
#define N_IDP		11
	{ "_nspcb"},
#define N_IDPSTAT	12
	{ "_idpstat"},
#define N_SPPSTAT	13
	{ "_spp_istat"},
#define N_NSERR		14
	{ "_ns_errstat"},
#define	N_CLNPSTAT	15
	{ "_clnp_stat"},
#define	IN_NOTUSED	16
	{ "_tp_inpcb" },
#define	ISO_TP		17
	{ "_tp_refinfo" },
#define	N_TPSTAT	18
	{ "_tp_stat" },
#define	N_ESISSTAT	19
	{ "_esis_stat"},
#define N_NIMP		20
	{ "_nimp"},
#define N_RTREE		21
	{ "_rt_tables"},
#define N_CLTP		22
	{ "_cltb"},
#define N_CLTPSTAT	23
	{ "_cltpstat"},
#define	N_NFILE		24
	{ "_nfile" },
#define	N_FILE		25
	{ "_file" },
#define N_IGMPSTAT	26
	{ "_igmpstat" },
#define N_MRTPROTO	27
	{ "_ip_mrtproto" },
#define N_MRTSTAT	28
	{ "_mrtstat" },
#define N_MFCHASHTBL	29
	{ "_mfchashtbl" },
#define	N_MFCHASH	30
	{ "_mfchash" },
#define N_VIFTABLE	31
	{ "_viftable" },
#define N_IPX		32
	{ "_ipxcbtable"},
#define N_IPXSTAT	33
	{ "_ipxstat"},
#define N_SPXSTAT	34
	{ "_spx_istat"},
#define N_IPXERR	35
	{ "_ipx_errstat"},
#define N_AHSTAT	36
	{ "_ahstat"},
#define N_ESPSTAT	37
	{ "_espstat"},
#define N_IP4STAT	38
	{ "_ipipstat"},
#define N_DDPSTAT	39
	{ "_ddpstat"},
#define N_DDPCB		40
	{ "_ddpcb"},
#define N_ETHERIPSTAT	41
	{ "_etheripstat"},
#define N_IP6STAT	42
	{ "_ip6stat" },
#define N_ICMP6STAT	43
	{ "_icmp6stat" },
#define N_IPSECSTAT	44
	{ "_ipsecstat" },
#define N_IPSEC6STAT	45
	{ "_ipsec6stat" },
#define N_PIM6STAT	46
	{ "_pim6stat" },
#define N_MRT6PROTO	47
	{ "_ip6_mrtproto" },
#define N_MRT6STAT	48
	{ "_mrt6stat" },
#define N_MF6CTABLE	49
	{ "_mf6ctable" },
#define N_MIF6TABLE	50
	{ "_mif6table" },
	{ ""},
};


static kvm_t *kvmd;
char *nlistf = NULL, *memf = NULL;

int kread( u_long addr, char *buf, int size )
{
  if( kvmd == 0 )
      return 1;
  if( !buf )
    return 0;
  if( kvm_read( kvmd, addr, buf, size ) != size )
      return 1;
  return 0;
}

int intpr( struct io_stat *io )
{
  struct ifnet ifnet;
  u_long ifaddraddr;
  char name[IFNAME_MAX];
  struct ifnet_head ifhead;
  u_long ifnetaddr = nl[ N_IFNET ].n_value;
  if( ifnetaddr == 0 )
    {
      return 1;
    }
  if( kread( ifnetaddr, (char *) &ifhead, sizeof( ifhead ) ) )
    {
      return 1;
    }
  ifnetaddr = (u_long) ifhead.tqh_first;
  ifaddraddr = 0;
  while( ifnetaddr || ifaddraddr )
    {
      if( ifaddraddr == 0 )
	{
	  if( kread( ifnetaddr, (char *)&ifnet, sizeof( ifnet ) ) )
	    return 1;
	  memset( name, 0, IFNAME_MAX );
	  if( !ifnet.if_xname )
	    return 1;
	  strncpy( name, ifnet.if_xname, IFNAME_MAX );
	  ifnetaddr = (u_long) ifnet.if_list.tqe_next;
	  if( interface != 0 )
	    if( strcmp( name, interface ) == 0 )
	      break;
	    else 
	      continue;
	  else
	    break;
	}
    }
  strncpy( io->ifname, name, IFNAME_MAX );
  io->ibytes = ifnet.if_ibytes;
  io->obytes = ifnet.if_obytes;
  return 0;
}

int init_kvm( )
{
  char buf[512];
  if( ( kvmd = kvm_openfiles( nlistf, memf, NULL, O_RDONLY, buf ) ) == NULL )
    {
      fprintf( stderr, "Unable to init kvm: %s\n", buf );
      return 1;
    }
  if( kvm_nlist( kvmd, nl ) < 0 || nl[0].n_type == 0 )
    {
      fprintf( stderr, "kvm: no namelist\n" );
      return 1;
    }
  return 0;
}

