/* $Id: log.c,v 1.2 2001/03/19 17:04:20 tcg Exp $ */

/* This log.c sends a UDP packet to a remote host, using the configurations below. The format of the packet is: "hostname interface incomingbytes outgoingbytes" */

/* You can customize it to fit your unique logging desires :) */

#include <stdio.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <netdb.h>
#include <sys/socket.h>
#include <string.h>
#include <unistd.h>

struct sockaddr_in their_addr;
int sockfd;
char hostname[ BUFSIZ ];
extern char *interface; /* from io.c */

/* Configurations (Sorry, didnt had time to make these dynamic, yet */
#define LOGHOST "localhost"
#define LOGPORT 9999

/* This function initializer the logger. Change it if you want.
 * Returns 0 on success, 1 on failure. */
int loginit( )
{
  struct hostent *he;
  if( ( hostname[0] == NULL ) && ( gethostname( hostname, BUFSIZ ) ) == -1 )
    {
      return 1;
    }
  if( ( he = gethostbyname( LOGHOST ) ) == NULL )
    {
      return 1;
    }
  if( ( sockfd = socket( AF_INET, SOCK_DGRAM, 0 ) ) == -1 )
    {
      return 1;
    }
  their_addr.sin_family = AF_INET;
  their_addr.sin_port = htons( LOGPORT );
  their_addr.sin_addr = *( ( struct in_addr *) he->h_addr );
  bzero( &(their_addr.sin_zero), 8 );
  return 0;
}

/* Log the data, return 0 on success, 1 on failure */
int log( u_long ibytes, u_long obytes )
{
  char buf[ BUFSIZ ];
  snprintf( buf, BUFSIZ, "%s %s %lu %lu\n", hostname, interface ? interface : "DEFAULT", ibytes, obytes );
  sendto( sockfd, buf, strlen( buf ), 0, (struct sockaddr *) &their_addr, sizeof( struct sockaddr ) );
  return 0;
}
