/* $Id: logger.c,v 1.1 2001/03/19 13:52:58 tcg Exp $ */

#include <stdio.h>
#include <sys/types.h>
#include <unistd.h>
#include <netdb.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include "config.h"

int server_sock;

/* Prototypes from sql.c */
int sqlinit( );
int sqllog( char*, char*, u_long, u_long );
/* Local prototypes */
int init_server( );
void event_loop( );

int main( int argc, char *argv[] )
{
  if( sqlinit( ) )
    {
      fprintf( stderr, "Unable to connect to the MySQL database\n" );
      return 1;
    }
  //  sqllog( "a", "b", 1, 2 );
  if( init_server( ) == -1 )
    {
      fprintf( stderr, "Unable to bind socket\n" );
      return 1;
    }
  event_loop( );
  return 0;
}

int init_server( )
{
  int rc;
  struct sockaddr_in sin;
  sin.sin_family = AF_INET;
  sin.sin_port = htons( LOGPORT );
  sin.sin_addr.s_addr = INADDR_ANY;
  server_sock = socket( AF_INET, SOCK_DGRAM, 0 );
  if( server_sock < 0 )
    {
      return -1;
    }
  rc = bind( server_sock, (struct sockaddr *) &sin, sizeof( sin ) );
  if( rc < 0 )
    {
      close( server_sock );
      return -1;
    }
  return server_sock;
}

void event_loop( )
{
  char buf[512], iface[8], hostname[64];
  u_long ibytes, obytes;
  int rc;

  memset( buf, 0, sizeof( buf ) );
  while( read( server_sock, buf, sizeof( buf ) ) != -1 )
    {
      buf[strlen(buf)]=0;
      rc = sscanf( buf, "%[^ ] %[^ ] %lu %lu", hostname, iface, &ibytes, &obytes );
      memset( buf, 0, sizeof( buf ) );
      if( rc != 4 )
	continue;
      sqllog( hostname, iface, ibytes, obytes );
    }
}
