<?
/*
Graph.php is Copyrighted 2000,2001 by 
Andrew A. Neuschwander (andrew@neuschwander.org)
Information Technology Resource Center at The University of Montana, Missoula


This is a new set of classes for generating png graphs with php. 
For best reading, set your tabstop to 2.

Yo, monkey. This is gnu type software. Liscenced under the GPL version 2 or later.

*/

//This is a basic data class, simple x, y points
class Data 
{
	//These three variables are needed by the Graph base class, derived data classes should
	//maintain them. -- I refuse to write wraper funtions, php is object based not oriented
	var $name			=	"";					//Name of the dataset for the legend
	var $color		= "";					//A color for drawing the legend and data with.
	var $axis			=	1;					//1 for primary Y axis, 2 for secondary

	//Feel free to do what you want with these in derived classes, just make sure the constructor can handle it.
	var $x				=	array();		//An array of x values
	var $y				=	array();		//A corresponding array fo y values.

	//swanky little constructor
	function Data($name, $color, &$x, &$y, $axis=1) {
    $this->name = $name;
    $this->color = $color;
    $this->axis = $axis ? $axis : 1;
    $this->x = $x;
    $this->y = $y;
	}
}
class Graph 
{
	//general variables for the class.
	var $id				= "";					//php image id number
  var $title		=	"";					//Graph title
  var $ih	      = "";         //Image height
	var $iw	      = "";         //Image width
  var $bevel    = 2;          //Border, 'bevel', width
	var $ib;					//short bevel for calculations.
  var $textpad  = 3;          //Space around text that doesn't get drawing in.
  var $tp;					//short textpad for calculations, rather redundent
	var	$font			=	2;					//the imagefont to use
	var	$fw				= "";					//fontwidth, read only
	var $fw				= "";					//fontheight, read only
	var $gw				= "";					//graph width (drawing window)
	var	$gh				= "";					//graph height (drawing window)
	var	$gx				= "";					//up left corner of drawing window wrt the image dimension.
	var $gy				= "";					//other part of the above.
	var $data			=	array();		//Array in which to store Data objects.
	var $error		=	"";					//for error message passing

	//I still haven't decided where this stuff belongs. Here seems good even though its not
	//used by the base class, only by the derived classes.
	var	$y_min;
	var	$y_max;
	var	$y_ticks	=	0;
	var	$y_min2;
	var	$y_max2;
	var	$y_ticks2	=	0;
	var	$lpw;
	var	$lph;
	var	$lph2;
	var	$hgrid	=	1;
	var	$hgrid2	=	1;
	var	$vgrid	=	1;

	//the ro_vars array holds the name of read only variables.
	var $ro_vars	=	array("id", "ih", "iw", "font", "fw", "fh", "gw", "gh", "gx", "gy");
	var $intvars	=	array("id", "ih", "iw", "bevel", "ib", "textpad", "tp", "font", "fw", 
												"fh", "gw", "gh", "gx", "gy",  "y_space", "y_space2");
	
	//X Axis related stuff;
	var $x_label	=	"";					//Text to go along the X axis
	//REMOVE var	$x_ticks	= 10;					//The number of X axis ticks to display
	var $x_axis		=	TRUE;				//Should I draw this axis?
	var $x_top		=	TRUE;				//Should I draw a horiz line at the top of the graph.
	//REMOVE var $x_name		= "";					//The name of a global function.  The function should
	var $x_ticks_jump = 5; // jump between each tick <eran r.>
															
	//Y Axis (Primary) related stuff;
	var $y_label	= "";					//Label for the primary y axis
	//REMOVE var $y_name		= "";					//name of global function, see $x_name for details
	var $y_space	=	5;					//Number of characters to reserve for the Y axis tick labels.
	var $y_axis		=	TRUE;				//Should I draw this axis?

  //Y Axis (Secondary) related stuff;
	var $y_label2		= "";				//Label for the secondary y axis
	//REMOVE var $y_name2		= "";				//name of global function, see $x_name for details
	var $y_space2  	= 5;				//Number of characters to reserve for the Y axis tick labels.
	var $y_axis2		=	TRUE;			//Should I draw this axis?

	//The class constructor
	function Graph($x = 500, $y = 135) 
	{
		//set the image size and get an id.
		$this->ih = $y;
		$this->iw = $x;
		$this->id = imagecreate($x, $y);

		//setup some shorthand references
		$this->ib = &$this->bevel;
		$this->tp = &$this->textpad;
	}

	//Get the value of an internal variable
	function get($var) {
		$this->update();
		if (isset($this->$var)) {
			return ($this->$var);
		} else {
			$this->error = "no such variable in class: $var";
			return(FALSE);
		}
	}

	//A function to set variables.
	function set( $array ) {
		//step through all the passed in variables
		for (reset($array); $var=key($array); next($array)) {
			//Check to see if the var is in this class and is not read only
			if (isset($this->$var) and !in_array($var, $this->ro_vars)) {
				//If it is supposed to be and int, cast it.
				$this->$var = (in_array($var, $this->intvars)) ? (int)$array[$var] : $array[$var] ;
			}
		}
	}

	//check all variables and update the drawing window size
	function update() {
		$retval = 1; //Assume all is well.	
		$this->fh = imagefontheight($this->font);
		$this->fw = imagefontwidth($this->font);
		$ogh = $this->gh;
		//REMOVE $oy_max = $this->y_max;
		//REMOVE $oy_max2 = $this->y_max2;

		//update the gy first, find the length of the title/legend string.
		//From this, guess how many lines of text there are and how far to
		//to offset the top of the graph window (gy)
		$this->gy = $this->ib + $this->tp;
		$t_len = strlen($this->title);
		
		for (reset($this->data); $id=key($this->data); next($this->data))
		{
			$t_len += 1 + strlen($this->data[$id]->name);
		}

		$lines = ($t_len*$this->fw) / ($this->iw - 2*($this->tp+$this->ib));
		if ($lines)
		{
			$this->gy += ceil($lines)*($this->tp + $this->fh);
		}

		//update gx, 
		$this->gx = $this->ib + $this->tp;

		for(reset($this->data); $id=key($this->data); next($this->data))
		{
			if($this->data[$id]->axis == 1)
			{
				//This takes a guess at the string length by getting the tick label for the first
				//Y value of the Data object. Its not exact, but it gives us something.
				$this->gx += $this->fw*$this->y_space + 3*$this->tp;
				break;
			}
		}

		$lines = ($this->fw*strlen($this->y_label)) / ($this->ih - 2*($this->tp+$this->ib));
		if ($lines)
		{
			$this->gx += ceil($lines)*($this->tp + $this->fh); 
		}

		//update gh, if data is present, one line of tick text.
		$this->gh = $this->ih - ($this->gy + $this->ib + $this->tp);
		$this->gh ? --$this->gh : FALSE;

		if (count($this->data)) 
		{
			$this->gh -= $this->fh + 2*$this->tp;
		}

		$lines = ($this->fw*strlen($this->x_label)) / ($this->iw - 2*($this->tp+$this->ib));
		if ($lines)
		{
			$this->gh -= ceil($lines)*($this->tp + $this->fh);
		}

		//finaly, update gw, look for secondary y axis data and procede accordingly.
		$this->gw = $this->iw - ($this->gx + $this->ib + $this->tp);
		$this->gw ? --$this->gw : FALSE;

		for(reset($this->data); $id=key($this->data); next($this->data))
		{
			if($this->data[$id]->axis == 2)
			{
				$this->gw -= $this->fw*$this->y_space2 + 3*$this->tp;
				break;
			}
		}

		$lines = ($this->fw*strlen($this->y_label2)) / ($this->ih - 2*($this->tp+$this->ib));
		if ($lines) 
		{
			$this->gw -= ceil($lines)*($this->tp + $this->fh);
		} else {
			$this->gw -= $this->fh;
		}

		//REMOVE //update the y_max values, use gh if y_max is not set();
		//REMOVE if (empty($oy_max) or $oy_max == $ogh) {
		//REMOVE 	$this->y_max = $this->gh;
		//REMOVE }
		//REMOVE if (empty($oy_max2) or $oy_max2 == $ogh) {
		//REMOVE 	$this->y_max2 = $this->gh;
		//REMOVE }
	}


	//We need to have an object value or reference passed in so we 
	//can put in into the data array.
	function input(&$data_ref, $id = 0) {
		if (count($this->data) > 0 ) {
			if (isset($this->data[$id])) {
				$this->data[$id] = $data_ref;
			} else {
				array_push($this->data, $data_ref);
				end($this->data);
				$id = end($this->data);
			}
		} else {
			$id=1;
			$this->data[$id] = $data_ref;
		}
	}

	//plot draws a few things: title, ?_label?, the axes
	function plot() {
		$this->update();

		//we need some basic colors;
		$black = imagecolorallocate($this->id, 0,0,0);
		$offwhite = imagecolorallocate($this->id, 245,245,245);
		$lgrey    = imagecolorallocate($this->id,200,200,200);
		$dgrey    = imagecolorallocate($this->id,120,120,120);

		//This allocates one color per data set, replacing the color string with the color ID.
		//FIX -- this can't handle anything more than hex strings now
		for(reset($this->data); $id=key($this->data); next($this->data)) {
			$this->data[$id]->color = $this->color($this->data[$id]->color);
		}

		//Nice fill color
		imagefill($this->id, 0,0,$offwhite);

		//put a nice bevel on the image
		$ib = $this->bevel;
		while($ib) {
			imageline($this->id,0,$ib-1,$this->iw-$ib,$ib-1, $lgrey);
			imageline($this->id,$ib-1,$this->ib,$ib-1,$this->ih-$ib,$lgrey);
			imageline($this->id,0,$this->ih-$ib,$this->iw-1,$this->ih-$ib,$dgrey);
			imageline($this->id,$this->iw-$ib,$ib-1,$this->iw-$ib,$this->ih-$this->ib,$dgrey);
			$ib--;
		} 

		//Draw the axis, or the 'box' around the graph area as the user sees fit.
		if ($this->x_top) {
			imageline($this->id, $this->gx, $this->gy, $this->gx+$this->gw, $this->gy, $black);
		}
		if ($this->x_axis) {
			imageline($this->id, $this->gx, $this->gy+$this->gh, $this->gx+$this->gw, $this->gy+$this->gh, $black);
		}
		if($this->y_axis) {
			imageline($this->id, $this->gx, $this->gy, $this->gx, $this->gy+$this->gh, $black);
		}
		if($this->y_axis2) {
			imageline($this->id, $this->gx+$this->gw, $this->gy, $this->gx+$this->gw, $this->gy+$this->gh, $black);
		}
		
		//Now add the X axis label.
		$label_width = strlen($this->x_label)*$this->fw;
		if ($label_width < $this->iw-2*($this->ib+$this->tp)) {
			$x_start = ($this->iw - $label_width)/2;
			$y_start = $this->ih-$this->ib-$this->tp-$this->fh;
			imagestring($this->id, $this->font, $x_start, $y_start, $this->x_label, $black);
		} else {
			//FIX -- I'll add this later, its not that important now.
			echo "Your X_Label is way to long :)";
		}

		//Now add the primary Y axis.
		$label_width = strlen($this->y_label)*$this->fw;
		if ($label_width < $this->ih-2*($this->ib+$this->tp)) {
			 $x_start = $this->ib+$this->tp;
			 $y_start = ($this->ih + $label_width)/2;
			 imagestringup($this->id, $this->font, $x_start, $y_start, $this->y_label, $black);
		} else {
			//FIX -- dude, you have a long label
			echo "Your Y_Label is way to long :)";
		}

		//Now add the secondary Y axis.
		$label_width = strlen($this->y_label2)*$this->fw;
		if ($label_width < $this->ih-2*($this->ib+$this->tp)) {
			$x_start = $this->iw - $this->ib - $this->tp - $this->fh;
			$y_start = ($this->ih + $label_width)/2;
			imagestringup($this->id, $this->font, $x_start, $y_start, $this->y_label2, $black);
		} else {
			//FIX -- dude, you have a long label
			echo "Your Y_Label2 is way to long :)";
		}

		//Just talking about my data so I can see whats up with it.
		//for(reset($this->data); $id=key($this->data); next($this->data)) {
		//	echo $this->data[$id]->name, " ", $this->data[$id]->axis, "<br>";
		//}
		
		//Now do the Title.
		$length = strlen($this->title);
		for(reset($this->data); $id=key($this->data); next($this->data)) {
			$length += strlen($this->data[$id]->name) + 1;
		}

		if ($length*$this->fw < $this->iw - 2*($this->tp+$this->ib)) {
			$xstart = ($this->iw - ($length*$this->fw))/2;
			$ystart = $this->ib+$this->tp;
			imagestring($this->id, $this->font, $xstart, $ystart, $this->title, $black);
			$xstart += strlen($this->title)*$this->fw;
			for(reset($this->data); $id=key($this->data); next($this->data)) {
				$pad = ($id == 1) ? " " : "/";
				imagestring($this->id, $this->font, $xstart, $ystart, $pad, $black);
				$xstart += $this->fw;
				imagestring($this->id, $this->font, $xstart, $ystart, $this->data[$id]->name, $this->data[$id]->color);
				$xstart += strlen($this->data[$id]->name) * $this->fw;
			}
		} else {
			//FIX -- wow, thats long I can't handle that yet.
			echo "Oh! You have a long title!";
		}
	}

	function output($file="") {
		if (empty($file)) {
			imagepng($this->id);
		} else {
			//list ($msec, $sec)  = split(" ",  microtime());
			imagepng($this->id, $file);
			//list ($msec2, $sec2)  = split(" ",  microtime());
			//echo "ImagePNG in:  ",  ($sec2+$msec2) - ($sec+$msec), " seconds<br>\n";
		} 
	}

	function color($hex) {
		$r = hexdec($hex[0].$hex[1]);
		$g = hexdec($hex[2].$hex[3]);
		$b = hexdec($hex[4].$hex[5]);
		return(imagecolorallocate($this->id, $r,$g,$b));
	} 

}
class BarGraph extends Graph
{
	var	$style = "dense"; //dense, sparse, overlap, or stacked
	var $spacing = "auto";	//auto, or an integer, 0 for no spacing (obviously)
	var	$values = false; //yes or no, to draw the values at the top of each bar.

	//Not setable by the user
	var $xvals = array();
	var $ymaxs = array();
	var $yminx = array();
	var $ymaxs2 = array();
	var $ymins2 = array();
	var $xmax;
	var $xmin;

	function plot() {
		Graph::plot();
		if (!$this->logical()) return(0);
		$this->xlabel();
	}


	function xlabel() {
		$black = imagecolorallocate($this->id, 0,0,0);
		$xcount = count($this->xvals) -1;
		$xspace = $this->gw / $xcount;
		$xpad = $xspace / 2;
		for($i=0; $i<$xcount; $i++) {
			imageline($this->id, $this->gx+$xpad+($i*$xspace),$this->gy+$this->gh, $this->gx+$xpad+($i*$xspace),$this->gy+$this->gh+$this->tp, $black);
			$txt = $this->xvals[$i+1]; 
			$offset = (strlen($txt) / 2 ) * $this->fw;
			imagestring($this->id, $this->font, $this->gx+$xpad+($i*$xspace)-$offset, $this->gy+$this->gh+$this->tp, $txt, $black);
		}
	}
	
	//Setup the x,y max and min values. Stacked is a special case, since we have to build all the 
	//stacked value arrays. Not only do we have an absolute max and min, but two man  and min y values
	//for each x value.
	function logical() {
		if ($this->style == "stacked") {
			for(reset($this->data); skey($this->data, $id); next($this->data)) {
				if ($this->data[$id]->axis == 1) {
					for(reset($this->data[$id]->x); skey($this->data[$id]->x, $i); next($this->data[$id]->x)) {
						if (!in_array($this->data[$id]->x[$i], $this->xvals)){
							$this->xvals[] = $this->data[$id]->x[$i];
						}
						if(!isset($this->ymaxs[$this->data[$id]->x[$i]])) {
							if ($this->data[$id]->y[$i] > 0) {
								$this->ymaxs[$this->data[$id]->x[$i]] = $this->data[$id]->y[$i];
								$this->ymins[$this->data[$id]->x[$i]] = 0;
							}	else {
								$this->ymins[$this->data[$id]->x[$i]] = $this->data[$id]->y[$i];
								$this->ymaxs[$this->data[$id]->x[$i]] = 0;
							}
						} else {
							if ($this->data[$id]->y[$i] > 0) {
								$this->ymaxs[$this->data[$id]->x[$i]] += $this->data[$id]->y[$i];
							} else {
								$this->ymins[$this->data[$id]->x[$i]] -= $this->data[$id]->y[$i];
							}
						}
					}
				} else {
					for(reset($this->data[$id]->x); skey($this->data[$id]->x, $i); next($this->data[$id]->x)) {
						if (!in_array($this->data[$id]->x[$i], $this->xvals)){
							$this->xvals[] = $this->data[$id]->x[$i];
						}
            if(!isset($this->ymaxs2[$this->data[$id]->x[$i]])) {
              if ($this->data[$id]->y[$i] > 0) {
                $this->ymaxs2[$this->data[$id]->x[$i]] = $this->data[$id]->y[$i];
                $this->ymins2[$this->data[$id]->x[$i]] = 0;
              } else {
                $this->ymins2[$this->data[$id]->x[$i]] = $this->data[$id]->y[$i];
                $this->ymaxs2[$this->data[$id]->x[$i]] = 0;
              }
            } else {
              if ($this->data[$id]->y[$i] > 0) {
                $this->ymaxs2[$this->data[$id]->x[$i]] += $this->data[$id]->y[$i];
              } else {
                $this->ymins2[$this->data[$id]->x[$i]] -= $this->data[$id]->y[$i];
              }
            }
					}
				}
			}
			sort($this->xvals);
			$this->xmin = reset($this->xvals);
			end($this->xvals);
			$this->xmax = current($this->xvals);
			arsort($this->ymaxs);
			$this->ymax = reset($this->ymaxs);
			asort($this->ymins);
			$this->ymin = reset($this->ymins);
			arsort($this->ymaxs2);
			$this->ymax2 = reset($this->ymaxs2);
			asort($this->ymins2);
			$this->ymin2 = reset($this->ymins2);
		} else {
			for(reset($this->data); skey($this->data, $id); next($this->data)) {

				//max and min x values
				asort($this->data[$id]->x);
				for(reset($this->data[$id]); skey($this->data[$id]->x, $v); next($this->data)) {
					if (!in_array($this->data[$id]->x[$v], $this->xvals)){
						$this->xvals[] = $this->data[$id]->x[$v];
					}
				}
				if (isset($this->xmin) ) {
					$this->xmin = (reset($this->data[$id]->x) < $this->xmin) ? current($this->data[$id]->x) : $this->xmin;
				} else {
					$this->xmin = reset($this->data[$id]->x);
				}
				if (isset($this->xmax)) {
					$this->xmax = (end($this->data[$id]->x) > $this->xmax) ? current($this->data[$id]->x) : $this->xmax;
				} else {
					$this->xmax = end($this->data[$id]->x);
				}

				//Dirty trick, I don't know if it works, TEST later
				if ($this->data[$id]->axis == 1) {
					$tmin = "ymin";
					$tmax = "ymax";
				} else {
					$tmin = "ymin2";
					$tmax = "ymax2";
				}

				//max and min y values.
				asort($this->data[$id]->y);
        if (isset($this->$tmin) ) {
          $this->$tmin = (reset($this->data[$id]->y) < $this->$tmin) ? current($this->data[$id]->y) : $this->$tmin;
        } else {
          $this->$tmin = reset($this->data[$id]->y);
        }
        if (isset($this->$tmax)) {
          $this->$tmax = (end($this->data[$id]->y) > $this->$tmax) ? current($this->data[$id]->y) : $this->$tmax;
        } else {
          $this->$tmax = end($this->data[$id]->y);
        } 
			}
		}
		return(1);
	}
}
class LineGraph extends Graph
{
	var $x_min;
	var $x_max;
	var $x_ticks	=	"";
	
	function plot() {
		Graph::plot();
		//REMOVE $this->gy += 1;
		//REMOVE $this->gh -= 1;
		if (! $this->gooddata()) {
			echo "You data sucks, something is bad.<br>", $this->error, "<br>";
			return(0);
		}
		if (! $this->logical()) {
			echo "I didn't set the logical values correctly.<br>", $this->error, "<br>";
			return(0);
		}
		$this->drawgrid();
		$this->drawdata();
	}
	
	function genpoints() {
		for(reset($this->data); skey($this->data, $id); next($this->data)) {
			$this->data[$id]->real = array();
			$lph = ($this->data[$id]->axis == 1) ? $this->lph : $this->lph2;
			$min = ($this->data[$id]->axis == 1) ? $this->y_min : $this->y_min2;
			for(reset($this->data[$id]->x); skey($this->data[$id]->x, $idx); next($this->data[$id]->x)) {
				$x = $this->gx + (($this->data[$id]->x[$idx] - $this->x_min ) / $this->lpw);
				$this->data[$id]->real[$x] = ($this->gh+$this->gy) - (($this->data[$id]->y[$idx] - $min ) / $lph);
			}
		}
	}

	function drawdata() {
		$this->genpoints();
		for(reset($this->data); skey($this->data, $id); next($this->data)) {
			unset($px, $x);
			for(reset($this->data[$id]->real); skey($this->data[$id]->real, $x); next($this->data[$id]->real)) {
				if (isset($px)) {
					imageline($this->id, $px, $this->data[$id]->real[$px], $x, $this->data[$id]->real[$x], $this->data[$id]->color);
					$px = $x;
				} else {
					imageline($this->id, $x, $this->data[$id]->real[$x], $x, $this->data[$id]->real[$x], $this->data[$id]->color);
					$px= $x;
				}
			}
		}
	}

	function gooddata() {
		//check all datasets
		for (reset($this->data); $id=key($this->data); next($this->data)) {
			//check to see that the number of x and y values match
			if (count($this->data[$id]->x) != count($this->data[$id]->y)) {
				$this->error = "Bad data: set $id has a x, y count mismatch ";
				return(0);
			}
			//check to see if the x points are sequential
			unset($prev);
			for(reset($this->data[$id]->x); skey($this->data[$id]->x, $idx); next($this->data[$id]->x)) {
			//echo "idx: $idx, x: ", $this->data[$id]->x[$idx], " y: ", $this->data[$id]->y[$idx], " prev: ", $prev, "<br>";
				if (isset($prev)){
					if ($prev > $this->data[$id]->x[$idx]) {
						//echo "data sorting in progress...<br>";
						//We need to resort the X/Y pairs.
						asort($this->data[$id]->x);
						unset($tmp);
						$tmpx = array();
						$tmpy = array();
						for(reset($this->data[$id]->x); $idx=key($this->data[$id]->x); next($this->data[$id]->x)) {
							if (isset($tmp)) {
								array_push($tmpx, $this->data[$id]->x[$idx]);
								array_push($tmpx, $this->data[$id]->y[$idx]);
							} else {
								$tmpx[1] = $this->data[$id]->x[$idx];
								$tmpy[1] = $this->data[$id]->y[$idx];
								$tmp = 1;
							}
						}
						$this->data[$id]->x = &$tmpx;
						$this->data[$id]->y = &$tmpy;
						break;
					} elseif ($prev == $this->data[$id]->x[$idx]) {
						$this->error = "Bad data: set $id is not one-to-one";
						return(0);
					}
					$prev = $this->data[$id]->x[$idx];
				} else {
					$prev = $this->data[$id]->x[$idx];
				}
			}
		}
		return(1);
	}

	function logical() {
		$uymin = $this->y_min;
		$uymax = $this->y_max;
		//step through the datasets
		for(reset($this->data); skey($this->data, $id); next($this->data)) {
			//Find the range.
			$xlow = reset($this->data[$id]->x);
			$xhigh = end($this->data[$id]->x);
			//Now discover the domain.
			asort($this->data[$id]->y);
			$ylow = reset($this->data[$id]->y);
			$yhigh = end($this->data[$id]->y);
			//Now put them in the right place
			if (isset($this->x_min)) {
				$this->x_min = ($this->x_min > $xlow) ? $xlow : $this->x_min;
				$this->x_max = ($this->x_max < $xhigh) ? $xhigh : $this->x_max;
			} else {
				$this->x_min = $xlow;
				$this->x_max = $xhigh;
			} 
			//assign y values to the correct axis
			if($this->data[$id]->axis == 1) {
				if (isset($this->y_min) and !isset($uymin)) {
					$this->y_min = ($this->y_min > $ylow) ? $ylow : $this->y_min;
					$this->y_max = ($this->y_max < $yhigh) ? $yhigh : $this->y_max;
				} else {
					$this->y_min = $ylow;
					$this->y_max = $yhigh;
				}
			} else {
				if (isset($this->y_min2)) {
					$this->y_min2 = ($this->y_min2 > $ylow) ? $ylow : $this->y_min2;
					$this->y_max2 = ($this->y_max2 < $yhigh) ? $yhigh : $this->y_max2;
				} else {
					$this->y_min2 = $ylow;
					$this->y_max2 = $yhigh; 
				}
			}
		}
		$this->lpw = ($this->x_max - $this->x_min) / $this->gw;
		$this->lph = ($this->y_max - $this->y_min) / $this->gh;
		$this->lph2 = ($this->y_max2 - $this->y_min2) / $this->gh;

		//This crap will go someday
		//REMOVE echo "Xmax: ", $this->x_max, ", Xmin: ", $this->x_min, "<br>";
		//REMOVE echo "Ymax: ", $this->y_max, ", Ymin: ", $this->y_min, "<br>";
		//REMOVE echo "Ymax2: ", $this->y_max2, ", Ymin2: ", $this->y_min2, "<br>";
		//REMOVE echo "LPW: ", $this->lpw, " LPH: ", $this->lph, " LPH2: ", $this->lph2, "<br>";

		return(1);
	}

	function drawgrid() {
		$black = imagecolorallocate($this->id, 0,0,0);
		$grey = imagecolorallocate($this->id, 200,200,200);
		//Y Axis (Primary) ticks
		if ($this->y_ticks > 0) {
			$ext_ticks = $this->y_ticks + 1;
			$tsep = ($this->gh / $ext_ticks);
			for($i=0 ; $i<=$ext_ticks ; $i++) {
				$y_real = (($this->gy+$this->gh) - ($i * $tsep));
				$y_logi = $this->y_min + ($i * $tsep * $this->lph);
				imageline($this->id, $this->gx-$this->tp, $y_real, $this->gx, $y_real, $black);
				if ($this->hgrid and $i > 0 and $i < $ext_ticks) {
					imageline($this->id, $this->gx+1, $y_real, $this->gx+$this->gw-1, $y_real, $grey);
				}
				$xstart = $this->gx - ($this->fw*$this->y_space) - 2*$this->tp;
				$ystart = $y_real - ($this->fh/2);
				$string = substr($y_logi, 0, $this->y_space);
				//$string = substr("123456789", 0, $this->y_space);
				while(strlen($string) < $this->y_space) {
					$string = " " . $string;
				}
				imagestring($this->id, $this->font, $xstart, $ystart, $string, $black);
			}
		}
		//Y Axis (Secondary) ticks
		if ($this->y_ticks2 > 0) {
			$ext_ticks = $this->y_ticks2 +1;
			$tsep = $this->gh / $ext_ticks;
			for($i=0; $i<=$ext_ticks; $i++) {
				$y_real = (($this->gy+$this->gh) - ($i * $tsep));
				$y_logi = $this->y_min2 + ($i * $tsep * $this->lph2);
				imageline($this->id, $this->gx+$this->gw, $y_real, $this->gx+$this->gw+$this->tp, $y_real, $black);
				if ($this->hgrid2 and $i > 0 and $i < $ext_ticks) {
					imagedashedline($this->id, $this->gx+1, $y_real, $this->gx+$this->gw-1, $y_real, $grey);
				}
				$xstart = $this->gx + $this->gw + 3*$this->tp;
				$ystart = $y_real - ($this->fh/2);
				$string = substr($y_logi, 0, $this->y_space2);
				//$string = substr("123456789", 0, $this->y_space2);
				imagestring($this->id, $this->font, $xstart, $ystart, $string, $black);
			}
		}
		//X Axis ticks
		$this->x_ticks = ($this->x_ticks < 1) ? count($this->data[1]->x) : $this->x_ticks;
		$ext_ticks = $this->x_ticks;
		$tsep = $this->gw / ($ext_ticks -1);
		for ($i=0; $i<$ext_ticks; $i++) {
			$x_real = $this->gx + ($i*$tsep);
			$x_logi = $this->x_min + ($i * $tsep * $this->lpw);
			imageline($this->id, $x_real, $this->gh+$this->gy, $x_real, $this->gh+$this->gy+$this->tp, $black);
			if($this->vgrid and $i > 0 and $i < ($ext_ticks - 1)) {
				imageline($this->id, $x_real, $this->gy+1, $x_real, $this->gy+$this->gh-1, $grey);
			}
			/* $string = substr($x_logi, 0, 4); <Ugly hack by Eran R, to make this work the way I want it. */
			$string = $i * $this->x_ticks_jump;
			$xstart = $x_real - ((strlen($string)*$this->fw)/2);
			$ystart = $this->gy + $this->gh + $this->tp;
			imagestring($this->id, $this->font, $xstart, $ystart, $string, $black);
		}
	}
}
class TSGraph extends LineGraph
{

}
function skey(&$array, &$var)  {
	$tmp = key($array);
	if (isset($tmp)) {
		$var = $tmp;
		return(1);
	} else {
		return (0);
	}
}
?>
